//************************************************************
//                      Muad Dib 2003
//   This example shows you how to make a simle "Find file"
//  program. If you think that this program is useful and
//  helped you to learn something new, please vote for me
//  at http://www.planet-source-code.com.
//
//   You can find my other useful examples there, too.
//   If you have any questions or problems using this or any
//  plese leave a note at the same web site.
//
//   Good luck.
//
//************************************************************

unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Types, QDialogs, shellapi;

type
  TformMenuPrincipal = class(TForm)
    Panel1: TPanel;
    bBuscar: TButton;
    opSubCarpetas: TCheckBox;
    Panel2: TPanel;
    LWEB: TLabel;
    Label3: TLabel;
    txtRuta: TEdit;
    bSeleccionarRuta: TButton;
    txtComodines: TEdit;
    Label4: TLabel;
    Panel3: TPanel;
    lInfo: TLabel;
    mTemp: TMemo;
    dGuardar: TSaveDialog;
    Panel4: TPanel;
    Splitter1: TSplitter;
    lLista: TListBox;
    bLimpiarLista: TButton;
    bGuardar: TButton;
    Splitter2: TSplitter;
    procedure bBuscarClick(Sender: TObject);
    procedure bLimpiarListaClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
    procedure bSeleccionarRutaClick(Sender: TObject);
    procedure bGuardarClick(Sender: TObject);
  private
   CurrentDir:string;
  public
  end;

var
  formMenuPrincipal: TformMenuPrincipal;
  procedure buscarFicheros (filtro, carpeta : string; Recursiva:boolean);
  procedure GetSubDirs(Folder:string;slist:TStringList);

implementation

{$R *.dfm}

procedure buscarFicheros (filtro, carpeta : string; Recursiva : boolean);
var
  sr : TSearchRec;
  sListaCarpetas : TStringList;
  i, numero : integer;
begin
  numero := 0;
  if FindFirst(carpeta + Filtro, faAnyFile, sr) = 0 then
  begin
    repeat
      numero := numero + 1;
      formmenuprincipal.lLista.Items.Add(carpeta + sr.Name);
      formMenuPrincipal.mTemp.Lines.Add(carpeta + sr.Name);
      formMenuPrincipal.lInfo.Caption := inttostr(formMenuPrincipal.lLista.Count) +
          ' fichero(s) encontrado(s) hasta el momento';
      formMenuPrincipal.Refresh;
    until FindNext(sr) <> 0;
  end;
  FindClose(sr);
  if Recursiva then
  begin
    sListaCarpetas := TStringList.Create;
    try
      GetSubDirs(carpeta, sListaCarpetas);
      for i := 0 to sListaCarpetas.Count - 1 do
      begin
        if (sListaCarpetas[i] <> '.') and (sListaCarpetas[i] <> '..') then
        begin
          Application.ProcessMessages;
          buscarFicheros(filtro, IncludeTrailingPathDelimiter(carpeta +
              sListaCarpetas[i]), Recursiva);
        end;
      end;
    finally
      sListaCarpetas.Free;
    end;
  end;
end;

procedure GetSubDirs(Folder:string; sList:TStringList);
 var
  sr:TSearchRec;
begin
  if FindFirst(Folder+'*.*',faDirectory,sr)=0 then
   try
    repeat
      if(sr.Attr and faDirectory)=faDirectory then
       sList.Add(sr.Name);
    until FindNext(sr)<>0;
   finally
    FindClose(sr);
   end;
end;           
procedure TformMenuPrincipal.bBuscarClick(Sender: TObject);
begin
 if (txtComodines.Text = '') then
   MessageDlg ('Debe introducir algn comodn para la bsqueda.', mtinformation, [mbok], 0)
 else
 begin
   lInfo.Caption := 'Buscando, espere por favor...';
   bLimpiarLista.Enabled := false;
   bSeleccionarRuta.Enabled := false;
   bBuscar.Enabled := false;
   bGuardar.Enabled := false;
   txtRuta.Enabled := false;
   txtComodines.Enabled := false;
   lLista.Clear;
   mTemp.Clear;
   buscarFicheros(txtComodines.Text, txtRuta.Text, opSubCarpetas.Checked);
   beep;
   lInfo.Caption := 'Bsqueda completada, ' + IntToStr(lLista.Items.Count) +
       ' fichero(s) encontrado(s)';
   if lLista.Count > 0 then
   begin
     bLimpiarLista.Enabled := true;
     bGuardar.Enabled := true;
   end;
   bSeleccionarRuta.Enabled := true;
   bBuscar.Enabled := true;
   txtRuta.Enabled := true;
   txtComodines.Enabled := true;
 end;
end;

procedure TformMenuPrincipal.bLimpiarListaClick(Sender: TObject);
begin
  lLista.Clear;
  lInfo.Caption := '';
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.bSeleccionarRutaClick(Sender: TObject);
var
  dir : String;
begin
  if SelectDirectory('Carpeta en donde inicar la bsqueda','',dir) then
  begin
    CurrentDir := dir;
    dir := IncludeTrailingPathDelimiter(dir);
    txtRuta.Text := dir;
  end;
end;

procedure TformMenuPrincipal.bGuardarClick(Sender: TObject);
begin
  if dGuardar.Execute then
    mTemp.Lines.SaveToFile(dGuardar.FileName);
end;

end.
